module Chan where 

import Parser.Abs
import Parser.ErrM
import Parser.Par

import Backend.Abs
import Backend.Print

import GenErr

data ChanData 
    = Integer 

declChannel :: LowIdent -> GenErr BEStatement:
declChannel var =  lowide

receiveOnChannel :: LowIdent -> ChanData -> GenErr BEStatement
receiveOnChannel lowident chandata = do 
    return $ BEStatementExpression $ BEEFunk (BEEVar ( 
    createChannelFunction ("rec" ++ readLowIdent lowident) stmts where
        stmts  = [StmtCall (CapIdent "Lock" )]

createChannelFunction :: String -> [Stmt] -> GenErr BEGlobalFunction
createChannelFunction name stmts = return $ BEGlobalFunc $ BEFunction types ident [] comp where 
  types = BEType [] BEPrimitiveVoid []
  ident = BEIdent name
  comp =  BECompound $ [] stmts
