module Includes where 

import Backend.Abs
import Parser.Abs

genInclude :: String
genInclude = "#include <instruction.h> \n" ++
  "#include <stack.h> \n" ++
  "#include <proc.h> \n" ++
  "#include <type.h> \n" ++
  "#include <work.h> \n" ++
  "#include <stdio.h> \n" ++
  "#include <unistd.h> \n" ++
  "#include <chan.h> \n"

genMain :: BEIdent
genMain = BEIdent "Main"

genNull :: String
genNull = "NULL" 

genPrint :: String
genPrint = "printf" 

genProcEnum :: String
genProcEnum = "ProcStatus"

genProcStruct :: String
genProcStruct = "Proc"

genProcStatus :: String
genProcStatus = "procStatus"

genDeadline :: String -> String
genDeadline procName =  procName ++ "_var_deadline"

genProcessVarName :: String -> String
genProcessVarName str = str ++ "_var_count" 

genStatusRunning :: String
genStatusRunning = "ProcRunning"

genStatusReady :: String
genStatusReady = "ProcReady" 

genStatusWaiting :: String
genStatusWaiting = "ProcWaiting" 

genStatusDone :: String
genStatusDone = "ProcDone" 

genStatusMainDone :: String
genStatusMainDone = "ProcMainDone" 


genStack :: String
genStack = "stack"

genProc :: String
genProc = "proc"

genParentStack :: String
genParentStack = "parent"

genStackPc :: String
genStackPc = "stack->pc" 

genStackVar :: String
genStackVar = "vars"

genStackStruct :: String
genStackStruct = "Stack"

genStackStructPoint :: String
genStackStructPoint = genStackStruct ++ "*"

genFinalizeLabel ::String
genFinalizeLabel = "finalize"


--Channel function
genChannel :: String
genChannel = "Channel"

genChanInitName :: String
genChanInitName = "initChannels"

genChanInit :: String
genChanInit = "initChannel"

genChanFreeName :: String
genChanFreeName = "freeChannels"

genChanFree :: String
genChanFree = "freeChannel"


genChanSend :: String
genChanSend = "sendOnChannel"

genChanSendSynch :: String
genChanSendSynch = "sendOnChannelSynch"

genChanReceive :: String
genChanReceive = "receiveOnChannel"

genChanReceiveSynch :: String
genChanReceiveSynch = "receiveChannelSynch"

genChanCheck :: String
genChanCheck = "channelReady"

genChanStatusVar :: String
genChanStatusVar =  "chan_status"

genChanRegWaitingRecv :: String
genChanRegWaitingRecv = "regProcAsWaitingRecv"

genChanRegWaitingSend :: String
genChanRegWaitingSend = "regProcAsWaitingSend"

genChanAddDepToChan :: String
genChanAddDepToChan = "addProcAsDep"

genChanRegProcFunc :: BEIdent -> BEIdent
genChanRegProcFunc x = case x of 
    BEIdent str -> BEIdent $ str ++ "_chan_dep"

genChanRegProcFuncStr :: String -> String
genChanRegProcFuncStr str = str ++ "_chan_dep"

--Queue function
genInitQueue :: String
genInitQueue = "initQueue"

--Stack functions 
genReadStack :: String
genReadStack = "readFromStack"

genWriteStack :: String
genWriteStack = "writeToStack"

--Processes
genInitWorkers :: String
genInitWorkers = "initWorkers"

genWaitWorkers :: String
genWaitWorkers = "waitWorkers"

genNewProc :: String
genNewProc = "newProc"

genAddDepProc :: String
genAddDepProc = "addDepProc"

--Work
genWorkVar :: LowIdent
genWorkVar =  LowIdent "work_i"

genWorkLim :: Integer
genWorkLim = 10

genWorkMsg :: String
genWorkMsg = "work"

--Mutex
 
genMutexLock :: String
genMutexLock = "pthread_mutex_lock"

genMutexUnlock :: String 
genMutexUnlock = "pthread_mutex_unlock"

genLock :: String
genLock = "lock"
