-- This Happy file was machine-generated by the BNF converter
{
module Parser.Par where
import Parser.Abs
import Parser.Lex
import Parser.ErrM
}

%name pProgramSpec ProgramSpec

-- no lexer declaration
%monad { Err } { thenM } { returnM }
%tokentype { Token }

%token 
 ':' { PT _ (TS ":") }
 ';' { PT _ (TS ";") }
 '{' { PT _ (TS "{") }
 '}' { PT _ (TS "}") }
 '[' { PT _ (TS "[") }
 ']' { PT _ (TS "]") }
 '=' { PT _ (TS "=") }
 '!' { PT _ (TS "!") }
 '?' { PT _ (TS "?") }
 '+' { PT _ (TS "+") }
 '-' { PT _ (TS "-") }
 ',' { PT _ (TS ",") }
 '(' { PT _ (TS "(") }
 ')' { PT _ (TS ")") }
 'CHAN' { PT _ (TS "CHAN") }
 'DeSchedule' { PT _ (TS "DeSchedule") }
 'FOR' { PT _ (TS "FOR") }
 'Ms' { PT _ (TS "Ms") }
 'Ns' { PT _ (TS "Ns") }
 'PAR' { PT _ (TS "PAR") }
 'PROC' { PT _ (TS "PROC") }
 'Print' { PT _ (TS "Print") }
 'S' { PT _ (TS "S") }
 'SEQ' { PT _ (TS "SEQ") }
 'TO' { PT _ (TS "TO") }
 'Us' { PT _ (TS "Us") }
 'VAR' { PT _ (TS "VAR") }
 'Work' { PT _ (TS "Work") }

L_integ  { PT _ (TI $$) }
L_quoted { PT _ (TL $$) }
L_CapIdent { PT _ (T_CapIdent $$) }
L_LowIdent { PT _ (T_LowIdent $$) }
L_err    { _ }


%%

Integer :: { Integer } : L_integ  { (read $1) :: Integer }
String  :: { String }  : L_quoted { $1 }
CapIdent    :: { CapIdent} : L_CapIdent { CapIdent ($1)}
LowIdent    :: { LowIdent} : L_LowIdent { LowIdent ($1)}

ProgramSpec :: { ProgramSpec }
ProgramSpec : ListGlobDecl { Program (reverse $1) } 


GlobDecl :: { GlobDecl }
GlobDecl : 'PROC' CapIdent ':' DeadLine ':' SingleBlock { GlobalProcessDecl $2 $4 $6 } 
  | Chan ';' { GlobalChannelDecl $1 }


ListGlobDecl :: { [GlobDecl] }
ListGlobDecl : {- empty -} { [] } 
  | ListGlobDecl GlobDecl { flip (:) $1 $2 }


SingleBlock :: { SingleBlock }
SingleBlock : '{' ListVar StmtCompound '}' { SingleBlock (reverse $2) $3 } 


StmtCompound :: { StmtCompound }
StmtCompound : Order 'FOR' LowIdent AssignOp Integer 'TO' Integer ':' StmtBlock { StmtFor $1 $3 $4 $5 $7 $9 } 
  | Order StmtBlock { StmtOrder $1 $2 }


ListStmtCompound :: { [StmtCompound] }
ListStmtCompound : {- empty -} { [] } 
  | ListStmtCompound StmtCompound { flip (:) $1 $2 }


StmtBlock :: { StmtBlock }
StmtBlock : '{' ListStmt '}' { StmtBlock (reverse $2) } 


Order :: { Order }
Order : 'PAR' { OrderPar } 
  | 'SEQ' { OrderSeq }


ListOrder :: { [Order] }
ListOrder : {- empty -} { [] } 
  | ListOrder Order { flip (:) $1 $2 }


DeadLine :: { DeadLine }
DeadLine : Integer 'S' { DeadLineS $1 } 
  | Integer 'Ms' { DeadLineMs $1 }
  | Integer 'Us' { DeadLineUs $1 }
  | Integer 'Ns' { DeadLineNs $1 }


ListDeadLine :: { [DeadLine] }
ListDeadLine : {- empty -} { [] } 
  | ListDeadLine DeadLine { flip (:) $1 $2 }


Stmt :: { Stmt }
Stmt : LowIdent AssignOp Expr ';' { StmtAssign $1 $2 $3 } 
  | LowIdent Array AssignOp Expr ';' { StmtArrayAssign $1 $2 $3 $4 }
  | 'DeSchedule' ';' { StmtDeSchedule }
  | CapIdent ';' { StmtCall $1 }
  | Expr ';' { StmtExpr $1 }
  | 'Work' ';' { StmtWork }
  | StmtCompound { StmtCompound $1 }
  | 'Print' String ListExpr { StmtPrint $2 $3 }
  | ChanCom ';' { StmtChanCom $1 }
  | Stmt ';' { $1 }


ListStmt :: { [Stmt] }
ListStmt : {- empty -} { [] } 
  | ListStmt Stmt { flip (:) $1 $2 }


Chan :: { Chan }
Chan : 'CHAN' LowIdent { ChanVar $2 } 
  | 'CHAN' LowIdent Array { ChanArray $2 $3 }


ListChan :: { [Chan] }
ListChan : {- empty -} { [] } 
  | ListChan Chan ';' { flip (:) $1 $2 }


Var :: { Var }
Var : 'VAR' LowIdent { Var $2 } 
  | 'VAR' LowIdent Array { VarArray $2 $3 }


ListVar :: { [Var] }
ListVar : {- empty -} { [] } 
  | ListVar Var ';' { flip (:) $1 $2 }


Array :: { Array }
Array : '[' Expr ']' { Array $2 } 


ListArray :: { [Array] }
ListArray : {- empty -} { [] } 
  | ListArray Array { flip (:) $1 $2 }


AssignOp :: { AssignOp }
AssignOp : '=' { Assign } 


ChanCom :: { ChanCom }
ChanCom : ChanExpr '!' Expr { ChanComSend $1 $3 } 
  | ChanExpr '?' Expr { ChanComRecv $1 $3 }


ListChanCom :: { [ChanCom] }
ListChanCom : {- empty -} { [] } 
  | ListChanCom ChanCom ';' { flip (:) $1 $2 }


ChanExpr :: { ChanExpr }
ChanExpr : LowIdent { ChanExpr $1 } 
  | LowIdent '[' Expr ']' { ChanExprArray $1 $3 }


ListChanExpr :: { [ChanExpr] }
ListChanExpr : {- empty -} { [] } 
  | ListChanExpr ChanExpr ';' { flip (:) $1 $2 }


Expr1 :: { Expr }
Expr1 : Expr1 '+' Expr2 { Plus $1 $3 } 
  | Expr1 '-' Expr2 { Min $1 $3 }
  | Expr2 '[' Expr2 ']' { ExprArray $1 $3 }
  | Expr2 { $1 }


Expr4 :: { Expr }
Expr4 : Integer { Numb $1 } 
  | Expr5 { $1 }


Expr5 :: { Expr }
Expr5 : LowIdent { ExprVar $1 } 
  | '(' Expr ')' { $2 }


ListExpr :: { [Expr] }
ListExpr : {- empty -} { [] } 
  | Expr ';' ListExpr { (:) $1 $3 }
  | {- empty -} { [] }
  | Expr { (:[]) $1 }
  | Expr ',' ListExpr { (:) $1 $3 }


Expr :: { Expr }
Expr : Expr1 { $1 } 


Expr2 :: { Expr }
Expr2 : Expr3 { $1 } 


Expr3 :: { Expr }
Expr3 : Expr4 { $1 } 



{

returnM :: a -> Err a
returnM = return

thenM :: Err a -> (a -> Err b) -> Err b
thenM = (>>=)

happyError :: [Token] -> Err a
happyError ts =
  Bad $ "syntax error at " ++ tokenPos ts ++ if null ts then [] else (" before " ++ unwords (map prToken (take 4 ts)))

myLexer = tokens
}

