module Parser.Skel where

-- Haskell module generated by the BNF converter

import Parser.Abs
import Parser.ErrM
type Result = Err String

failure :: Show a => a -> Result
failure x = Bad $ "Undefined case: " ++ show x

transCapIdent :: CapIdent -> Result
transCapIdent x = case x of
  CapIdent str  -> failure x


transLowIdent :: LowIdent -> Result
transLowIdent x = case x of
  LowIdent str  -> failure x


transProgramSpec :: ProgramSpec -> Result
transProgramSpec x = case x of
  Program globdecls  -> failure x


transGlobDecl :: GlobDecl -> Result
transGlobDecl x = case x of
  GlobalProcessDecl capident deadline singleblock  -> failure x
  GlobalChannelDecl chan  -> failure x


transSingleBlock :: SingleBlock -> Result
transSingleBlock x = case x of
  SingleBlock vars stmtcompound  -> failure x


transStmtCompound :: StmtCompound -> Result
transStmtCompound x = case x of
  StmtFor order lowident assignop n0 n stmtblock  -> failure x
  StmtOrder order stmtblock  -> failure x


transStmtBlock :: StmtBlock -> Result
transStmtBlock x = case x of
  StmtBlock stmts  -> failure x


transOrder :: Order -> Result
transOrder x = case x of
  OrderPar  -> failure x
  OrderSeq  -> failure x


transDeadLine :: DeadLine -> Result
transDeadLine x = case x of
  DeadLineS n  -> failure x
  DeadLineMs n  -> failure x
  DeadLineUs n  -> failure x
  DeadLineNs n  -> failure x


transStmt :: Stmt -> Result
transStmt x = case x of
  StmtAssign lowident assignop expr  -> failure x
  StmtArrayAssign lowident array assignop expr  -> failure x
  StmtDeSchedule  -> failure x
  StmtCall capident  -> failure x
  StmtExpr expr  -> failure x
  StmtWork  -> failure x
  StmtCompound stmtcompound  -> failure x
  StmtPrint str exprs  -> failure x
  StmtChanCom chancom  -> failure x


transChan :: Chan -> Result
transChan x = case x of
  ChanVar lowident  -> failure x
  ChanArray lowident array  -> failure x


transVar :: Var -> Result
transVar x = case x of
  Var lowident  -> failure x
  VarArray lowident array  -> failure x


transArray :: Array -> Result
transArray x = case x of
  Array expr  -> failure x


transAssignOp :: AssignOp -> Result
transAssignOp x = case x of
  Assign  -> failure x


transChanCom :: ChanCom -> Result
transChanCom x = case x of
  ChanComSend chanexpr expr  -> failure x
  ChanComRecv chanexpr expr  -> failure x


transChanExpr :: ChanExpr -> Result
transChanExpr x = case x of
  ChanExpr lowident  -> failure x
  ChanExprArray lowident expr  -> failure x


transExpr :: Expr -> Result
transExpr x = case x of
  Plus expr0 expr  -> failure x
  Min expr0 expr  -> failure x
  ExprArray expr0 expr  -> failure x
  Numb n  -> failure x
  ExprVar lowident  -> failure x



