module VarState where 

import List
import Control.Monad.State

import Parser.ErrM

import Backend.Abs

import GenErr

addToLocal :: BEExp -> Int -> GenErr ()
addToLocal var n = getVarState >>= \vs -> modifyVarState $ ((head vs)
                   { vsLocal = (var, n) : (vsLocal (head vs)) }) : (tail vs)
    
upVarScope :: GenErr ()
upVarScope = getVarState >>= \vs -> modifyVarState $ (VarState []) : vs

downVarScope :: GenErr ()
downVarScope = getVarState >>= \vs -> modifyVarState $ tail vs

{--Finds in which scope level the variable was decleared and 
    its position on the stack
    --}
lookForVar :: BEExp -> GenErr (Int, Int)
lookForVar var = do 
    vars <- getVarState
    checkVarState 0 var vars

checkVarState :: Int -> BEExp -> [VarState] -> GenErr (Int, Int)
checkVarState n var (x:xs) = do
    let (exprs, pos) = unzip $ vsLocal x 
    case findIndex (==var) exprs of 
        Just i -> do
            let stackPos = pos !! i
            return $ (n, stackPos)
        Nothing -> checkVarState ( n + 1 ) var xs 
checkVarState _ var [] = lift $ Bad $ "Undefined variable " ++ show var
