#include <stdlib.h>
#include "type.h"
#include "chan.h"

struct Channel *initChannel() {
    struct Channel *chan = malloc(sizeof(struct Channel));
    chan->recv = NULL;
    chan->send = NULL;
#ifdef __DEP__
    chan->depProc = linkedListProcInit();
#endif //__DEP__
    chan->lock = malloc(sizeof(pthread_mutex_t));
    pthread_mutex_init(chan->lock, NULL);
    return chan;
}

void freeChannel(struct Channel *chan) {
#ifdef __DEP__
    linkedListProcFree(chan->depProc);
#endif //__DEP__
    pthread_mutex_destroy(chan->lock);
    free(chan->lock);
    free(chan);
}

int channelReady(struct Channel *chan){
    int stat = chan->waiting != 0;
    return stat;
}

void synchChannel(struct Channel *, struct Proc *proc);

int receiveOnChannel(struct Channel *chan) {
    return chan->data;
}

int receiveChannelSynch(struct Channel *chan) {
    synchChannel(chan, chan->send);
    return chan->data;
}

void sendOnChannel(int var, struct Channel *chan) {
    chan->data = var;
}


void sendOnChannelSynch(int var, struct Channel *chan) {
    chan->data = var;
    synchChannel(chan, chan->recv);
}

void regProcAsWaitingRecv(struct Channel *chan, struct Proc *proc) {
    chan->recv = proc;
    (chan->waiting) ++;
}

void regProcAsWaitingSend(struct Channel *chan, struct Proc *proc) {
    chan->send = proc;
    (chan->waiting)++;
}
    
void synchChannel(struct Channel *chan, struct Proc *proc) {
    if(!chan || !proc) {
        return;
    }
    moveFromWaitingQueueToReadyQueue(proc);
}
void addProcAsDep(struct Channel *chan, struct Proc *proc) {
#ifdef __DEP__
   linkedListProcQueue(chan->depProc, proc);
   linkedListChanQueue(proc->depChan, chan);
#endif //__DEP__
}
