#ifndef __CHAN__
#define __CHAN__

#include <stdbool.h>
#include "proc.h"
#include "linkedList.h"

struct Channel {
    int data;
    struct Proc *recv;
    struct Proc *send;
#ifdef __DEP__
    struct LinkedListProc *depProc;
#endif //__DEP__
    unsigned int waiting;
    pthread_mutex_t *lock;
};

struct Channel *initChannel();
void freeChannel(struct Channel *);
int channelReady(struct Channel*);

int receiveOnChannel(struct Channel *);
int receiveChannelSynch(struct Channel *);

void sendOnChannel(int, struct Channel *);
void sendOnChannelSynch(int, struct Channel *);

void regProcAsWaitingRecv(struct Channel*, struct Proc*);
void regProcAsWaitingSend(struct Channel*, struct Proc*);

void addProcAsDep(struct Channel *, struct Proc *);
#endif //__CHAN__
