#ifndef __LINKEDLISTQUEUE__
#define __LINKEDLISTQUEUE__

#include <pthread.h>

struct LinkedListProc {
    struct LinkedListProcNode *start;
    struct LinkedListProcNode *end;
    pthread_mutex_t *lock;
};

struct LinkedListProcNode {
    struct Proc *proc;
    struct LinkedListProcNode *next;
};

struct LinkedListChan {
    struct LinkedListChanNode *start;
    struct LinkedListChanNode *end;
    pthread_mutex_t *lock;
};

struct LinkedListChanNode {
    struct Channel *chan;
    struct LinkedListChanNode *next;
};

struct LinkedListStack {
    struct LinkedListStackNode *start;
    struct LinkedListStackNode *end;
    pthread_mutex_t *lock;
};

struct LinkedListStackNode {
    struct Stack *stack;
    struct LinkedListStackNode *next;
};

struct LinkedListProc *linkedListProcInit();
void linkedListProcFree(struct LinkedListProc *);
void linkedListProcQueue(struct LinkedListProc *, struct Proc *);
struct Proc * linkedListProcDequeue(struct LinkedListProc *);

struct LinkedListChan *linkedListChanInit();
void linkedListChanFree(struct LinkedListChan *);
void linkedListChanQueue(struct LinkedListChan *, struct Channel *);
struct Channel * linkedListChanDequeue(struct LinkedListChan *);

struct LinkedListStack *linkedListStackInit();
void linkedListStackFree(struct LinkedListStack *);
void linkedListStackQueue(struct LinkedListStack *, struct Stack *);
struct Stack * linkedListStackDequeue(struct LinkedListStack *);


void linkedListMergeProcList(struct Proc *, struct LinkedListProc *, struct LinkedListProc *);
#endif //__LINKEDLISTQUEUE__
