#ifndef __PROC__
#define __PROC__

#include <pthread.h>
#include "type.h"

struct Worker {
    pthread_t thread;
    pthread_mutex_t workerLock;
    struct Proc *next;
};

void initQueue(void);
void initWorkers(void);
void waitWorkers(void);
void freeProc(struct Proc *proc);
struct Proc *newProc(void *procFunc,
                     int nVars,
                     int deadLine,
                     struct Stack *parent,
                     void (*chanDep)(struct Proc *), 
                     struct Proc *depProc);
void moveFromWaitingQueueToReadyQueue(struct Proc *);
void setNextProc(struct Worker *, struct Proc *);
void forceWaitingProcToNextProc(struct Proc *);
unsigned long long int clockDiff(unsigned long long dl);

#endif //__PROC__
