#ifndef __PROCQUEUE__
#define __PROCQUEUE__

#include <pthread.h>
#include <rbtree/rbtree.h>
#include <type.h>

struct ProcQueue {
	struct rb_root *root;
    pthread_mutex_t *queueLock;
};

struct ProcQueue *makeProcQueue(void);
void freeProcQueue(struct ProcQueue *queue) ;

void queueReadyProc(struct Proc *proc, struct ProcQueue *);
void queueWaitingProc(struct Proc *proc, struct ProcQueue *);

struct Proc *dequeueReadyProc(struct ProcQueue *);
struct Proc *dequeueWaitingProc(struct ProcQueue *, unsigned long long);

void removeReadyProcFromQueue(struct ProcQueue *, unsigned long long, unsigned long long);
void removeWaitingProcFromQueue(struct ProcQueue *, unsigned long long);
#endif //__PROCQUEUE__
