#ifndef __RBQUEUE__ 
#define __RBQUEUE__

#include <rbtree/rbtree.h>
#include <type.h>

struct DepList {
   struct Proc *proc;
   struct DepList *next;
};

struct rbTask {
    unsigned long long pid;
    struct DepList dep;
    struct Proc *proc;
    struct rb_node node;
};

void rbPrintTree(struct rb_node *);

void rbPrint(struct rbTask *);

struct rbTask * rbSearchPid(struct rb_root *,unsigned long long);
struct rbTask * rbSearchDeadline(struct rb_root *, unsigned long long, unsigned long long);
struct rbTask * rbGetLowestDeadline(struct rb_root *root, unsigned long long);

void rbInsertDeadline(struct rb_root *, struct rbTask *);
void rbInsertPid(struct rb_root *, struct rbTask *);
 
void rbDeleteFull(struct rb_root *, struct rbTask *);
struct Proc *rbDeleteDeadline(struct rb_root *, unsigned long long, unsigned long long);
struct Proc *rbDeletePid(struct rb_root *, unsigned long long);

void rbFinish(struct rb_root *);

#endif //__RBQUEUE__
