#include <stdlib.h>
#include <string.h>
#include <type.h>


void copyStack(struct Stack *to, struct Stack *from);

struct Stack *makeStack(int nVars, int sizeVars, struct Stack *parent) {
	struct Stack *newProcStack = malloc(sizeof(struct Stack));
    
    newProcStack->pc = 0;
	newProcStack->vars = nVars == 0 ? NULL : malloc(sizeVars);
	newProcStack->nVars = nVars;
	newProcStack->size = sizeVars;
    newProcStack->parent = malloc(sizeof(struct Stack));
    if(parent)
        copyStack(newProcStack->parent, parent);
	
    return newProcStack;
}

void writeToStack(struct Stack *stack, int *vars) {
    memcpy(stack->vars, vars, stack->size);
}

int *readFromStack(struct Stack *stack){
    int *vars = malloc(stack->size);
    memcpy(vars, stack->vars, stack->size);
    return vars;
}

void copyStack(struct Stack *to, struct Stack *from) {
    memcpy(to, from, sizeof(struct Stack));
    to->vars = malloc(from->size);
    memcpy(to->vars, from->vars, from->size);
}

void freeStack(struct Stack *stack) {
    if(stack->vars){
        free(stack->vars);
        stack->vars = NULL;
    }
    free(stack);
}

void mergeStacks(struct Stack *orginal, struct Stack *to, struct Stack *from) {
    if(to->nVars && from->nVars && to->nVars == from->nVars && orginal->nVars == from->nVars && orginal->nVars == to->nVars){
        for (int i = 0; i <= to->nVars; i ++) {
            if(orginal->vars[i] != from->vars[i]) {
                to->vars[i] = from->vars[i];
            }
        }
    }
}
