#ifndef __TYPE__
#define __TYPE__

#include "linkedList.h"

enum ProcStatus {
	ProcWaiting = 0,
	ProcReady,
	ProcRunning,
    ProcDone,
    ProcMainDone,
};

struct Stack {
	int pc;
	int *vars;
	int nVars;
	int size;
    struct Stack *parent;
};

struct DepProcData {
    int num;
    struct LinkedListStack *childrenStack;
};

struct Proc {
    enum ProcStatus (*procFunc)(struct Stack *, struct Proc *);
    void *chanArg;
	struct Stack *stack;
    unsigned long long int deadline;
    unsigned long long int pid;
    enum ProcStatus status;
    struct LinkedListChan *depChan;
    struct LinkedListProc *depProc;
    struct DepProcData depProcData;
};


#endif //__TYPE__
